if(!dojo._hasResource["com.ibm.mm.builder.widget.MoveWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.MoveWidget"] = true;
dojo.provide("com.ibm.mm.builder.widget.MoveWidget");

dojo.require("com.ibm.mm.builder.widget.CustomDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.NumberSpinner");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");

dojo.declare("com.ibm.mm.builder.widget.MoveWidget",[dijit._Widget, dijit._Templated],{	
    templateString: 
    	'<div dojoAttachEvent="onkeypress: _onKeyPress" class="moveWidgetContainer">'+
			'<div class="moveWidgetDiv" dojoAttachPoint="containerNode">'+
				'<div class="moveWidgetItem" dojoAttachPoint="moveWidgetTopDiv">'+
					'<span class="moveWidget_item_label">${I_CONTEXT_MENU_WIDGET_TOP_LABEL}</span>'+
					'<input dojoType="dijit.form.NumberSpinner" type="text" dojoAttachPoint="widgetTopInput" '+ 
						'title="${TOP_INPUT_TITLE}" invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" '+
						'class="moveWidget_inputField" required="true" tabindex=0/>'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
				'<div class="moveWidgetItem" dojoAttachPoint="moveWidgetLeftDiv">'+
					'<span class="moveWidget_item_label">${I_CONTEXT_MENU_WIDGET_LEFT_LABEL}</span>'+
					'<input dojoType="dijit.form.NumberSpinner" type="text" dojoAttachPoint="widgetLeftInput" '+ 
						'title="${LEFT_INPUT_TITLE}" invalidMessage="${I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE}" '+
						'class="moveWidget_inputField" required="true" tabindex=0 />'+
				'</div>'+
				'<div class="clearthefloats"></div>' +
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" dojoAttachPoint="footer" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
			'</div>'+
		'</div>',
	
	TOP_INPUT_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_TITLE2,
	LEFT_INPUT_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_TITLE1,
	
	I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_INPUT_INVALIDMESSAGE,
	I_COMMON_CANCEL: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
	I_COMMON_SAVE: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE,
	I_CONTEXT_MENU_WIDGET_TOP_LABEL: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_TOP_LABEL,
	I_CONTEXT_MENU_WIDGET_LEFT_LABEL: builderConfig.isBidi ? 
		com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_RIGHT_LABEL : 
		com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_WIDGET_LEFT_LABEL,
	
	widgetsInTemplate: true,
	
	postCreate: function(){	
		this.uniDialog = new com.ibm.mm.builder.widget.CustomDialog(this.dlgPara);
		this.uniDialog.containerNode.appendChild(this.domNode);
		
		dojo.connect(this.uniDialog, "onResize", this, "onDialogResize");
		this._setA11YHint();
	},
	
	_setA11YHint: function() {
		var leftInput = dojo.query("input", this.moveWidgetLeftDiv)[0];
		dojo.attr(leftInput, "title", this.LEFT_INPUT_TITLE);
		
		var topInput = dojo.query("input", this.moveWidgetTopDiv)[0];
		dojo.attr(topInput, "title", this.TOP_INPUT_TITLE);
		
	},
	
	_onKeyPress:function(evt){
		if (evt.keyCode == dojo.keys.ENTER) {
			this.save();
		}
	},
	
	hide: function(){
		this.uniDialog.hide();
	},
	
	updateProperty: function(widgetId){
		this.widgetId = widgetId;
		
		this.widgetTopInput.constraints = {min: 0, places: 0};
		var widgetNode = com.ibm.pb.layout.LayoutParser.findById(widgetId);
				
		var pageWidthRange = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthRange();
		var widgetWidth = dojo.style(widgetNode, "width");
		//com.ibm.mm.builder.utils.skinUtil.getLocationValue("width", widgetId);
		this.widgetLeftInput.constraints = {min:0,max: pageWidthRange.max - widgetWidth, places:0};
				
		var top = dojo.style(widgetNode, "top");
		//var top = com.ibm.mm.builder.utils.skinUtil.getLocationValue("top",widgetId);
		if (top){
			top = parseInt(top,10);	
			this.widgetTopInput.setValue(top);		
		}else if(top === 0){
			this.widgetTopInput.setValue(0);
		}
		var left = dojo.style(widgetNode, builderConfig.isBidi ? "right" : "left");
		//var left = com.ibm.mm.builder.utils.skinUtil.getLocationValue(builderConfig.isBidi ? "right" : "left",widgetId);
		if (left){
			left = parseInt(left,10);		
			this.widgetLeftInput.setValue(left);
		}else if(left === 0){
			this.widgetLeftInput.setValue(0);
		}
		this.uniDialog.show();
	},
	
	setTitle: function(title) {
		if (this.uniDialog) {
			this.uniDialog.setTitle(title);
		}
	},
		
	save: function(){
		if (!(this.widgetTopInput.isValid() && this.widgetLeftInput.isValid())) { return; }
		
		var widget_left_coordinate = 0;
		var widgetNode = com.ibm.pb.layout.LayoutParser.findById(this.widgetId);
		if(builderConfig.isBidi){
			var widget_width = dojo.style(widgetNode, "width");
			var pageWidthRange = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthRange();
			//var widget_width = com.ibm.mm.builder.utils.skinUtil.getLocationValue("width", this.widgetId);
			var page_width = pageWidthRange.max;
			
			widget_left_coordinate = page_width - widget_width - this.widgetLeftInput.getValue();
			if (widget_left_coordinate < 0) {
				widget_left_coordinate = 0;
			}
		}else{
			widget_left_coordinate = this.widgetLeftInput.getValue();
		}
		
		this.moveWidget({
			id: this.widgetId,
			top: this.widgetTopInput.getValue()+"px", 
			left: widget_left_coordinate + "px"
		});
		this.hide();
	},
		
	moveWidget:function(widgetInfo){
		var widgetId = widgetInfo.id;
		var widgetNode = com.ibm.pb.layout.LayoutParser.findById(widgetId);
		if(!widgetNode.style.position){
			widgetNode.style.position="absolute";
		}
		widgetNode.style.left=widgetInfo.left;
		widgetNode.style.top=widgetInfo.top;
		var parent = widgetNode.parentNode;
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var lm = ibmCfg.controllers.dnd.nm.getLayoutModel(currentPageId);
		if (dojo.hasClass(parent, "ibmFreeform")){
			var oldHeight = dojo.coords(parent).h;
			var leastHeight = dojo.coords(widgetNode).h + parseInt(widgetInfo.top);
			if (oldHeight < leastHeight){
				parent.style.height = (leastHeight + 10) + "px";
				var _containerId = com.ibm.pb.layout.LayoutParser.extractID(parent);
				var ctrol = lm.find(_containerId).start();
				ctrol.setMetaData("css-style", "height:"+ (leastHeight + 10) +"px;");
			}
		}
		var lctl = lm.find(widgetId).start();
		lctl.setMetaData("css-style", widgetNode.style.cssText);	
	},

	onDialogResize: function(width, height) {
		var dialogContainerCB = dojo.contentBox(this.uniDialog.containerNode);
		var containerMB = dojo.marginBox(this.containerNode);
		var footerHeight = dojo.marginBox(this.footer.domNode).h;
		
		containerMB.w = dialogContainerCB.w;
		containerMB.h = dialogContainerCB.h - footerHeight;
		
		dojo.marginBox(this.containerNode, containerMB);
	}
});

}
