dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification");
dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringDisabledTip");
dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas");
dojo.require("com.ibm.mm.builder.utils.userUtil");
dojo.declare("com.ibm.mm.builder.systemwidget.autoWiringManager",null,{disabledTip:null,hwcBtnPos:null,displaySuccessNotification:false,autoWireWidget:null,layoutParser:com.ibm.pb.layout.LayoutParser,onLoad:function(){
var _1=this.iContext;
this.LOGGER=com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.systemwidget.autoWiringManager");
},onWireInterfaceDisplay:function(_2){
var _3=_2.payload;
if(!_3){
return;
}
var _4=com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
var _5=_4.getAutoWiringEnablement();
if(_5){
return;
}
},displayMessage:function(_6,_7,_8){
var _9=new com.ibm.widgets.StatusMessage(_6,_7,_8);
dojo.publish("/message/status",[{message:_9,uid:"ibmStatusBox"}]);
},isWidgetHidden:function(_a){
var _b=this.layoutParser.findById(_a);
if(dojo.attr(_b.parentNode,"name")=="ibmHiddenWidgets"){
return true;
}else{
return false;
}
},onAddNewWire:function(_c){
var _d=_c.payload;
var _e=com.ibm.mm.builder.utils.wireUtil.addWireCSA2(_d.sourceWidgetId,_d.sourceEvent,_d.targetWidgetId,_d.targetEvent);
if(_e){
if(!this.isWidgetHidden(_d.sourceWidgetId)){
com.ibm.pb.contextMenu.sharedActions.hideControl(_d.sourceWidgetId);
}
var _f=com.ibm.mm.builder.coreWidgetsStrings.I_QUICK_WIRE_CREATED_TITLE;
var msg=dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_QUICK_WIRE_CREATED,[com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(_d.sourceWidgetId),_d.sourceEvent,com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(_d.targetWidgetId)]);
this.displayMessage("info",_f,msg);
}else{
this._displayWirePane(_d.sourceWidgetId);
var _f=com.ibm.mm.builder.coreWidgetsStrings.I_QUICK_WIRE_ALREADY_CREATED_TITLE;
var msg=dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_QUICK_WIRE_ALREADY_CREATED,[com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(_d.sourceWidgetId),com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(_d.targetWidgetId)]);
this.displayMessage("info",_f,msg);
}
},autoWiringWidget:function(_10){
var _11=_10.payload;
if(!_11){
return;
}
var _12=com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
var _13=_12.getAutoWiringEnablement();
if(_13){
var _14=com.ibm.mm.builder.utils.wireUtil.setupAutoWiring(_11);
this.initAutoWiringSettings();
if(_14.hasAutoWire&&this.displaySuccessNotification){
this.autoWireWidget={id:_11,result:_14};
this._displayNotiWhenWidgetReady(_11);
}
}
},_displayNotiWhenWidgetReady:function(_15){
window.setTimeout(dojo.hitch(this,function(){
var div=this.layoutParser.findById(_15);
if(div){
this.onLayoutRefreshed();
}else{
this._displayNotiWhenWidgetReady();
}
}),100);
},onLayoutRefreshed:function(){
if(this.autoWireWidget){
var _16=this.getDialogLocation(this.autoWireWidget.id);
var _17=new com.ibm.mm.builder.iwidget.wiringscreen.AutoWiringNotification();
_17.showAutoWiringResult(this.autoWireWidget.id,this.autoWireWidget.result,_16);
this.autoWireWidget=null;
}
},_displayWirePane:function(_18){
var _19=com.ibm.mm.builder.utils.iwidgetUtil.getWidgetIconCSA2(_18);
var _1a={nodeWidth:"486px",title:com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME,titleIconUrl:_19,leftBarWidth:"18px",rightBarWidth:"12px",displayCloseButton:true,hasRightBottomResizer:false};
var _1b={widgetTypeId:"wireInterface",eventName:"com.ibm.mashups.builder.editWire",eventPayload:_18,dialogParam:_1a,requestRefresh:true};
com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",_1b);
},onQuickWireCreate:function(_1c){
var _1d=_1c.payload;
var _1e=_1d.sourceWidgetId;
var _1f=_1d.targetWidgetId;
var _20=com.ibm.mm.builder.utils.iwidgetUtil;
var _21=com.ibm.mm.builder.utils.wireUtil;
var _22=_20.getLayoutControl(_1e);
var _23=_20.getLayoutControl(_1f);
var _24=_21.getWidgetPublishedEventsCSA2(_22)[0];
var _25=_21.getWidgetHandledEventsCSA2(_23)[0];
var _26=com.ibm.mm.builder.coreWidgetsStrings.I_QUICK_WIRE_CANNOT_CREATE_TITLE;
var _27=dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_QUICK_WIRE_CANNOT_CREATE,[com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(_1e),com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(_1f)]);
if(_24&&_25){
var _28=_21.isEventCompatibleCSA2(_24,_25,1);
if(_28){
var _29={"sourceWidgetId":_1e,"sourceEvent":_24.getName(),"targetWidgetId":_1f,"targetEvent":_25.getName()};
com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.addNewWire",_29);
}else{
this._displayWirePane(_1e);
this.displayMessage("info",_26,_27);
}
}else{
this._displayWirePane(_1e);
this.displayMessage("info",_26,_27);
}
},initAutoWiringSettings:function(){
var _2a=com.ibm.mm.builder.utils.userUtil.getCurrentUser();
var _2b=com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS");
if(!_2b){
this.displaySuccessNotification=false;
}else{
var v1=_2a.getAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS");
if(v1===true||v1=="true"){
this.displaySuccessNotification=true;
}else{
this.displaySuccessNotification=false;
}
}
},onHWCPositionPublished:function(_2c){
this.hwcBtnPos=_2c.payload;
},getDialogLocation:function(_2d){
var div=this.layoutParser.findById(_2d);
var _2e=dojo.coords(div);
x=_2e.x+15;
y=_2e.y+15;
var _2f={x:x,y:y,inNVA:false};
return _2f;
},onWireGraphDisplay:function(_30){
var _31=_30.payload;
this.displayWireGraph(_31,true);
},displayWireGraph:function(_32,_33){
var _34=dijit.byId(_32+"_wiringCanvas");
if(_34){
_34.destroy();
}
this.wiringCanvas=new com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas({id:_32+"_wiringCanvas",selectedWidgetId:_32,alone:_33});
this.wiringCanvas.showGraph();
},onUnload:function(){
if(this.wiringCanvas){
this.wiringCanvas.destroy();
this.wiringCanvas=null;
}
}});

