<%@ page language="java" contentType="text/html;charset=UTF-8" %>
<%!
	public static boolean isBidi(final String locale) {
		return java.awt.ComponentOrientation.RIGHT_TO_LEFT.equals(java.awt.ComponentOrientation.getOrientation(new java.util.Locale(locale))) ? true : false;
	}
%>
<%
boolean isErrorScreen=request.getParameter("fail")!=null;
java.util.ResourceBundle bundle=java.util.ResourceBundle.getBundle("resources.bootstrap",request.getLocale());
com.ibm.mm.framework.services.IConfigService configService = com.ibm.mm.framework.Platform.getInstance().getConfigService();
	String localeStr = request.getLocale().toString().replace('_', '-').toLowerCase();
	String rtlClass=null;
	if (isBidi(localeStr)){
		rtlClass="mumrtl";
	}
	String dir="ltr";
	if (rtlClass!=null){
		dir="rtl";
	}
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="en">
<head>
    <title><%=configService.getString(com.ibm.mm.ConfigConstants.PRODUCT_NAME)%></title>
    <link rel="shortcut icon" href="/mum/images/favicon.ico" type="image/x-icon"/>
    <link rel="icon" href="/mum/images/favicon.ico" type="image/x-icon"/>  	
	<link rel="stylesheet" href="/mum/small_login.css" type="text/css"/>
	<script language="JavaScript" type="text/javascript">
	var supportedBrowsers=[/Firefox.3.6/g,/MSIE 6/g,/MSIE 7/g,/MSIE 8/g,/Opera.9.52/g,/Version.5.*Safari/g];
	var ua=navigator.userAgent;

	var isSupported=false;
	for(var i=0;i<supportedBrowsers.length;i++){
		if(ua.match(supportedBrowsers[i])){
			isSupported=true;
			break;
		} 
	}
	if(!isSupported){
		var msg="<%=bundle.getString("login.unsupportedBrowserWarning")%>";
		alert(msg);
	}	


	</script>	
	
	<style>

	.lotusBanner {
		background-color:#000000;
		background-image:-moz-linear-gradient(center top , #525252 0%, #000000 100%);
		padding:0 10px;
	}
	.lotusui .lotusLogo, .lotusLoginLogo {
		background-image:url("/mum/images/IBM_Mashup_Center_brand_White.png");
		height:18px;
		width:105px;
	}
	 
	body.lotusui {
		background-color:#F4F5F6;
		color:#222222;
		font:75%/1.5em Arial,Helvetica,sans-serif;
		margin:0;
		padding:0;
	}

	.lotusLogin2 .lotusLoginBox {
		background-color:#FFFFFF;
		border:1px solid #CCCCCC;
		margin:30px auto 10px;
		padding:0;
		width:385px;
	}
	.lotusLogin2 .lotusLoginBox h2 {
		font-size:1.1em;
		font-weight:bold;
		line-height:1.3em;
		margin:20px 0 5px;
	}

	.lotusLogin2 .lotusDescription {
		float:left;
		margin-top:25px;
		padding-left:5px;
		width:205px;
	}
	.lotusLogin2 .lotusLoginContent {
		padding:10px 20px 10px 40px;
		position:relative;
	}
	.lotusLogin2 .lotusLegal {
		color:#666666;
		margin:0 auto;
		text-align:center;
		width:475px;
	}
	.lotusLogin2 .lotusForm2 {
		background-color:transparent;
	}
	.lotusLogin2 .lotusForm2 .lotusFormError {
		margin-bottom:-10px;
	}
	.lotusLogin2 .lotusLoginForm {
		position:relative;
	}
	.lotusLogin2 .lotusLoginForm .lotusBtnContainer {
		margin-top:25px;
	}
	 
	.lotusLogin2 .lotusLoginForm p {
		clear:none;
		margin:15px 0 0;
		padding:0;
		width:auto;
	}
	.lotusLogin2 .lotusLoginForm label {
		margin-bottom:3px;
	}


	.lotusForm2 .lotusFormField {
		margin-bottom:10px;
	}
	 
	.lotusForm2 label {
		color:#222222;
		display:block;
		font-weight:bold;
		margin-bottom:3px;
		width:65%;
	}

	.lotusBtnContainer {
		margin-bottom:0;
		overflow:hidden;
		padding-bottom:0;
		white-space:nowrap;
	}
	.lotusLogin2 .lotusLoginForm .lotusText {
		width:20em;
	}

	.lotusForm2 .lotusText, .lotusForm2 textarea, .lotusForm2 select {
		border:1px solid #AAAAAA;
		padding:1px;
	}
	 
	.lotusForm2 input.lotusFormButton, .lotusForm2 button.lotusFormButton {
		border-color:#AAAAAA;
	}
	 
	.lotusBtn a, input.lotusBtn, button.lotusBtn, input.lotusFormButton, button.lotusFormButton, .lotusBtnImg {
		-moz-border-radius:2px 2px 2px 2px;
		border:1px solid #AAAAAA;
		color:#000000 !important;
	}
	 
	input.lotusFormButton, button.lotusFormButton {
		font-size:0.9em;
		margin-right:15px;
	}
	 
	input.lotusBtn, button.lotusBtn, input.lotusFormButton, button.lotusFormButton {
		cursor:pointer;
		padding:2px 7px 3px;
	}
	 
	.lotusBtn a, input.lotusBtn, button.lotusBtn, input.lotusFormButton, button.lotusFormButton, .lotusBtnImg {
		background-color:#F1F1F1;
		background-image:-moz-linear-gradient(center top , #FFFFFF 0%, #EBEBEB 100%);
		color:#000000 !important;
	}
	 
	.lotusui button, .lotusui input, .lotusui select {
		font-family:Arial,Helvetica,sans-serif;
		font-size:1em;
	}

	.lotusBtn, .lotusFormButton,  {
		border:1px solid #AAAAAA;
		font-weight:bold;
		text-align:center !important;
	}

	.lotusBtnContainer {
		white-space:nowrap;
	}
	 
	.lotusLegal .lotusLicense {
		color:#666666;
	}
	 
	table.lotusLegal td {
		padding:5px;
		vertical-align:middle;
		font-size:0.8em;
		line-height:1.2em;
	}

	.lotusLogin2 .lotusLegal {
		color:#666666;
		text-align:center;
	}
	.lotusui .lotusIBMLogo {
		background-position:0 -2185px;
		background-repeat:no-repeat;
		height:23px;
		width:64px;
	}
	.lotusui .lotusRight {
		float:right;
		text-align:right;
	}
	 
	.lotusForm2 .lotusFormError {
		font-weight:bold;
		margin-bottom:5px;
		color:#FF0000;
	}
	.oneUI table.mumLegal {
	   margin:0px 0px 0px;
	}

	</style>
</head>

<body class="lotusLogin2 lotusui oneUI <%=rtlClass%>" dir="<%=dir%>">
    <div  id="loginBoxDiv" class="lotusLoginBox">
        <div class="lotusLoginContent" role="region" aria-labelledby="loginForm">
            <form  id="loginForm"  aria-live="assertive" role="main" class="lotusForm2 lotusLoginForm" action="<%= response.encodeURL("j_security_check") %>"  method="POST" onsubmit="return submitLogin();">
              <h1><%=bundle.getString("login.productName")%></h1>              
			  <%if(isErrorScreen){%>                
			    <div id="signErrorDiv" class="lotusFormError" role="alert" style="display:none;">
                	 <%=bundle.getString("login.errorMsg")%> 
                </div>
				<%}%>  
                <p class="lotusFormField">
                    <label for="username">
                        <%=bundle.getString("login.userID")%>
                    </label>
                    <input class="lotusText" id="username" name="j_username" type="text"  aria-required="true" onkeyup="submitOnEnter(event)"/>
                </p>
                <p class="lotusFormField">
					<div>
						<label for="password">
							<%=bundle.getString("login.password")%>
						</label>
						<input class="lotusText" type="password" aria-required="true" name="j_password" id="password" onkeyup="submitOnEnter(event)">
					</div>
                </p>
                <div class="lotusBtnContainer">
                    <label style="display: none;" for="loginBn">
                        <%=bundle.getString("login.signIn")%>
                    </label>
                    <input type="button" id="loginBn" class="lotusFormButton" value="<%=bundle.getString("login.signIn")%>" role="button" wairole="button" aria-label="<%=bundle.getString("login.signIn")%>" onClick= "return submitForm(); " />
                    <span>
                        <a class="mumAction" id="loginHelp" title="<%=bundle.getString("login.help")%>" aria-label="<%=bundle.getString("login.help")%>" href="http://www-10.lotus.com/ldd/mashupswiki.nsf" target="_blank">
                            <%=bundle.getString("login.help")%>
                        </a>
                    </span>
                </div>
                <br/>
				 
            </form>
        </div>
    </div>
 
	<script language="JavaScript" type="text/javascript">
		if(window.location.hash.indexOf("#pid=")>=0){
			//set pid to support tomcat
			setCookie("pid", window.location.hash.substr(5));
			//WAS will clean any cookie except WASReqURL; 
			//WAS will aslo remove hash from the url so we change the cookie.
			//Because only FF will pass the hash to this page, this change only support FF.
			var wsu = getCookie("WASReqURL")
			if(wsu){
				if(wsu.indexOf("#pid")<0){
			   		setCookie("WASReqURL", wsu + window.location.hash)
				}
			}else{
				setCookie("WASReqURL", "/mum/enabler" + window.location.hash)
			}
		}
		
		var textboxUser=document.getElementById('username');
		var textboxPassword=document.getElementById('password');
		function submitForm(){
			if ((textboxUser.value.length > 0) && (textboxPassword.value.length) > 0) {
				document.getElementById('loginBn').setAttribute("href","#")
				document.forms[0].submit();
			}else{
				alert("<%=bundle.getString("login.errorMsg2")%>");
				return false;
			} 
		}
		function submitOnEnter(keyEvent){
			if(keyEvent.keyCode==13&&(textboxUser.value.length>0)&&(textboxPassword.value.length)>0){
				submitForm();
			}
		}
		textboxUser.focus();
		
		function getCookie(name){
		  var arr = document.cookie.match(new RegExp("(^| )"+name+"=([^;]*)(;|$)"));
		  if(arr != null) return unescape(arr[2]); return null;
		}
		
		function setCookie(name,value){
		  document.cookie = name + "="+ value;
		}
	</script>
</body> 
</html>
