dojo.provide("com.ibm.mm.builder.systemwidget.ControlledNavWidget");
dojo.require("com.ibm.pb.iwidget.iWidgetBase");
dojo.require("com.ibm.widgets.NavigationWidget");
dojo.require("com.ibm.dnd.PageCreator");
dojo.declare("com.ibm.mm.builder.systemwidget.ControlledNavWidget",com.ibm.pb.iwidget.iWidgetBase,{controller:null,dndOperable:false,varyLevelCondition:false,varyLevelInSpace:false,attachNode:null,firstItemClass:null,editorIWidgetID:null,selectionModel:null,isSwitching:false,onLoad:function(){
var _1="onLoad",_2=this.LOGGER,me=this;
_2.entering(_1,arguments);
var _3=this.iContext.getiWidgetAttributes();
var _4=this.getItemSetValues(["dndType","dndAccept","firstItemClass","attachNode","editorIWidgetID","varyLevelCondition","openDelay","popupDelay","closeDelay","level","levels","baseClass","tabListClass","tabClass","class","selectedClass","showInlineEditor","tiedToSelection","dndOperable","varyLevelInSpace","item","controller","dndCreator"]);
this.convertMapTypes(_4,["openDelay","popupDelay","closeDelay","level","levels"],"Number");
this.convertMapTypes(_4,["showInlineEditor","tiedToSelection","dndOperable"],"Boolean");
this.convertMapTypes(_4,["item","controller","dndCreator"],"Object");
if(_4.editorIWidgetID){
this.editorIWidgetID=_4.editorIWidgetID;
}
dojo.forEach(["dndOperable","controller","firstItemClass","attachNode","varyLevelCondition","varyLevelInSpace"],function(_5){
this[_5]=_4[_5];
delete _4[_5];
},this);
this.baseLevel=_4.level;
if((this.varyLevelInSpace&&this.controller.getCurrentSpaceId())||this.controller.getCurrentSpaceId()=="FAKE_SPACE"){
_4.level++;
}
this.selectionModel=this.controller.getSelectionModel();
var _6=dojo.delegate({model:this.controller.getTreeModel(),selectionModel:this.selectionModel,tiedToSelection:true,skipPreload:true,openDelay:0,closeDelay:500,popupDelay:500,dndClass:"com.ibm.pb.dnd.ControlledModeledSource",dndType:"nm",dndAccept:"nm",dndEnabled:false,dndCreator:com.ibm.dnd.PAGE_CREATOR.creator,showInlineEditor:this.showInlineEditor,baseClass:"",tabListClass:"lotusInlinelist lotusLinks",tabClass:"","class":"",selectedClass:"lotusSelected",inlineEditorWidgetParams:{onClick:function(){
var cb=dojo.hitch(me,function(){
com.ibm.pb.iwidget.control.onLoad(me.editorIWidgetID,function(){
me.evtSvc.broadcastEvent(me.builderEvents.CREATE_PAGE,{spaceId:me.controller.getCurrentSpaceId(),parentPageId:me.widget.model.getIdentity(me.widget.item)});
});
});
if(com.ibm.pb.contextMenu.sharedActions.widgetEditModeChecker()){
return;
}
if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().isDirty()){
var _7=com.ibm.mm.builder.coreWidgetsStrings;
var _8=new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({contentWarning:_7.I_PAGE_SAVE_WARNING,contentQuestion:_7.I_PAGE_SAVE_SUGGEST,btnSaveText:_7.I_COMMON_SAVE,btnNotSaveText:_7.I_PAGE_SAVE_NO_SAVE,btnCancelText:_7.I_PAGE_SAVE_KEEP_EDIT,callbackSave:cb,callbackNotSave:cb,hideNotSave:false,callbackCancel:function(){
}});
_8.show();
}else{
cb();
}
}},onModelItemClick:function(_9,_a){
_2.trace("closure","SWITCH_PAGE called via onModelItemClick ${0} ${1}",[_9,_a]);
me.evtSvc.broadcastEvent(me.builderEvents.SWITCH_PAGE,this.model.getIdentity(_a));
}},_4);
if(this.attachNode){
this.attachNode=dojo.byId(this.attachNode);
}
if(!this.attachNode){
this.attachNode=this.iContext.getRootElement();
}
this.widget=new com.ibm.widgets.NavigationWidget(_6,this.attachNode);
if(this.firstItemClass){
dojo.connect(this.widget,"onLoad",this.widget,function(){
var ch=this.getChildren();
if(ch.length>0){
dojo.addClass(ch[0].domNode,me.firstItemClass);
}
});
}
this.widget.startup();
com.ibm.mm.builder.utils.navigationUtil.updateSpaceTitleInNavBar();
_2.exiting(_1,arguments);
},onPageSwitched:function(_b){
var _c="onPageSwitched",_d=this.LOGGER;
_d.entering(_c,arguments);
if(this.dndOperable){
this.widget.disableDnd();
}
if(this.varyLevelInSpace&&this.controller.getCurrentSpaceId()&&this.widget.level==this.baseLevel){
_d.trace(_c,"Navigated into a space, reset level of nav widget ${0} to ${1}",[this,this.baseLevel+1]);
this.widget.attr("level",this.baseLevel+1);
this.refresh(_b.payload);
}
if(this.varyLevelInSpace&&!this.controller.getCurrentSpaceId()&&this.widget.level==this.baseLevel+1){
_d.trace(_c,"Navigated into a space, reset level of nav widget ${1} to ${0}",[this,this.baseLevel]);
this.widget.attr("level",this.baseLevel);
this.refresh(_b.payload);
}
com.ibm.mm.builder.utils.navigationUtil.updateSpaceTitleInNavBar();
_d.exiting(_c,arguments);
},onPageModeChanged:function(_e){
var _f="onPageModeChanged",lgr=this.LOGGER;
lgr.entering(_f,arguments);
if(this.dndOperable){
if(_e.payload==="edit"){
this.widget.setupDnd();
}else{
this.widget.disableDnd();
}
}
if(_e.payload==="edit"){
var pid=com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
var _10=com.ibm.pb.contextMenu.sharedActions.confirmCreateSiblingPage(pid);
this._showHideInlineEditor(_10);
}
lgr.exiting(_f,arguments);
},onRefreshNavigation:function(_11){
var _12="onRefreshNavigation",lgr=this.LOGGER;
lgr.entering(_12,arguments);
try{
this.refresh(_11.payload);
}
catch(e){
var msg=dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_NAV_REFRESH_NAVIGATION_1,[e.message]);
lgr.severe(_12,msg);
}
lgr.exiting(_12,arguments);
},refresh:function(pid){
var _13="refresh",lgr=this.LOGGER;
lgr.entering(_13,arguments);
this.widget.reload(true);
lgr.exiting(_13,arguments);
},onRefreshSpace:function(_14){
var _15="onRefreshSpace",lgr=this.LOGGER;
lgr.entering(_15,arguments);
com.ibm.mm.builder.utils.navigationUtil.updateSpaceTitleInNavBar();
lgr.exiting(_15,arguments);
},onUnload:function(){
var _16="onUnload",lgr=this.LOGGER;
lgr.entering(_16,arguments);
if(this.widget){
this.widget.destroy(true);
this.widget=null;
}
lgr.exiting(_16,arguments);
},onOpenPage:function(_17){
this.controller.onOpenPage(_17);
},onClosePage:function(_18){
this.controller.onClosePage(_18);
},_showHideInlineEditor:function(_19){
if(this.widget.inlineEditor){
var _1a=this.widget.inlineEditor.domNode;
if(_19){
_1a.style.display="";
}else{
_1a.style.display="none";
}
}
}});

