dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManager");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerWidget");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");
dojo.declare("com.ibm.mm.builder.spaceManagerWidget",null,{byId:function(id){
return dojo.byId(this.WID+id);
},onLoad:function(){
this._connections=[];
this._subscriptions=[];
this.iWidgetAttributes=this.iContext.getiWidgetAttributes();
var _1=this.iContext.widgetId;
this.WID="_"+_1+"_";
this.spaceManagerWidget=null;
this._constants=com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
this._constants.showPagesCount=this.iWidgetAttributes.getItemValue("showPagesCount");
this._constants.showPageOwner=this.iWidgetAttributes.getItemValue("showPageOwner");
this._constants.changeHideMenuItemLabel=this.iWidgetAttributes.getItemValue("changeHideMenuItemLabel");
this.eventService=com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
this._subscriptions.push(dojo.subscribe(this._constants.Topic.Space["switch"],this,this._switchSpace));
this._subscriptions.push(dojo.subscribe(this._constants.Topic.Space.switchPage,this,this._switchPage));
this.resourceBundle=com.ibm.mm.builder.coreWidgetsStrings;
this.dirtyFlag=false;
this._dialog_={open:false};
},onRefreshSpaceList:function(){
this.spaceManagerWidget.refresh();
},onShow:function(){
if(!this.spaceManagerWidget){
dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages",this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
var sm=new com.ibm.mm.builder.iwidget.spacemanager.SpaceManager();
var _2=this.byId("spaceManager");
this.spaceManagerWidget=new com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerWidget({spaceManager:sm},_2);
}else{
this.spaceManagerWidget.refresh();
}
this._dialog_=this.iContext.dialogContainer;
this._connections.push(dojo.connect(this._dialog_,"trueHide",this,"hide"));
dojo.byId(this.WID+"btn_done").value=this.resourceBundle.I_SPACE_MANAGER_DONE;
dojo.attr(dojo.byId(this.WID+"btn_done"),"aria-label",this.resourceBundle.I_SPACE_MANAGER_DONE);
this.deletedSpaces=[];
this.pageThemeChanged=[];
this.spaceOwnerChanged=[];
this.pageDeleted=[];
var _3=dojo.query("[dojoattachpoint='_inputNode']")[0];
this._dialog_.displayCallback=function(){
dijit.focus(_3);
};
var _4=com.ibm.mm.builder.utils.spaceUtil.getSpaceModel(true);
var s=new com.ibm.mashups.enabler.strategy.NoCacheStrategy();
_4.addStrategy(s);
var _5=com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
var s2=new com.ibm.mashups.enabler.strategy.NoCacheStrategy();
_5.addStrategy(s2);
},onSpaceCreated:function(_6){
if(this._dialog_.open){
this.spaceManagerWidget.onSpaceCreated(_6.payload);
this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
}else{
this.dirtyFlag=true;
}
},onExportSpace:function(_7){
if(_7&&_7.payload){
com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.exportSpace(_7.payload);
}
},onDeleteSpace:function(_8){
this.deletedSpaces.push(_8.payload);
com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
},onPageThemeChanged:function(_9){
var _a=_9.payload.pageId;
var _b=_9.payload.pageTitle;
if(this._dialog_.open){
this.pageThemeChanged.push(_a);
}else{
setTimeout(function(){
window.location.reload();
},0);
}
},onPageCreated:function(_c){
if(!this._dialog_.open){
this.dirtyFlag=true;
}
},onPageDeleted:function(_d){
var _e=_d.payload;
if(this._dialog_.open){
this.pageDeleted.push(_e);
}else{
this.dirtyFlag=true;
}
},onSpaceOwnerChanged:function(_f){
this.spaceOwnerChanged.push(_f.payload);
},onAddSpaceToFavorite:function(_10){
if(_10&&_10.payload){
com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.addSpaceToFavorite(_10.payload);
}
},onRemoveSpaceFromFavorite:function(_11){
if(_11&&_11.payload){
com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerActions.space.removeSpaceFromFavorite(_11.payload);
}
},_switchSpace:function(_12){
if(_12){
this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog",this.iContext.widgetId);
var _13=dojo.hitch(this,function(){
this.eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace",_12);
});
com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(_13);
}
},_switchPage:function(_14){
if(_14){
this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog",this.iContext.widgetId);
this.eventService.broadcastEvent("com.ibm.mashups.builder.switchPage",_14);
}
},_hideWithKey:function(e){
if(e.charCode==dojo.keys.SPACE||e.keyCode==dojo.keys.ENTER){
this.hide();
}
},hide:function(){
this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog",this.iContext.widgetId);
if(dojo.indexOf(this.pageThemeChanged,com.ibm.mm.builder.utils.pageUtil.getCurrentPageId())>-1){
setTimeout(function(){
window.location.reload();
},0);
}
if(this.pageDeleted.length>0){
dojo.forEach(this.pageDeleted,function(_15){
if(_15.pageId===_15.currentPageId){
var _16=_15.parentPageId;
com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchPage",_16);
}else{
com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
}
});
}
if(this.deletedSpaces.length>0){
dojo.forEach(this.deletedSpaces,function(_17){
if(_17.spaceId===_17.currentSpaceId){
com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchSpace","welcomeSpace");
}else{
com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
}
});
}
if(this.spaceOwnerChanged.length>0){
dojo.forEach(this.spaceOwnerChanged,function(_18){
if(_18.spaceId===_18.currentSpaceId){
var _19=com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(_18.spaceId);
var ea=com.ibm.mashups.enabler.ac.AccessFactory.getEffectiveAccess(_19);
if(!ea||ea.hasRole("UNKNOWN")){
com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.switchSpace",com.ibm.mm.builder.utils.spaceUtil.getHomeSpaceId()||com.ibm.mm.builder.utils.spaceUtil.getWelcomeSpaceId());
}
}else{
com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.refreshSpaceSelector");
}
});
}
var _1a=com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
_1a.removeStrategy("com.ibm.mashups.enabler.strategy.NoCacheStrategy");
var _1b=com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
_1b.removeStrategy("com.ibm.mashups.enabler.strategy.NoCacheStrategy");
},onUnload:function(){
dojo.forEach(this._connections,dojo.disconnect);
dojo.forEach(this._subscriptions,dojo.unsubscribe);
}});

